$(document).ready(function() {

    $('.custom-field-selection').find('.cloneable').each(function() {

        $(this).cloneable({
            pre_add_item_callback: function(item) {

                item.find('.field-options').css('display', 'none');
                item.find('.sub-cloneable').each(function(i,e) {

                    $(this).children('.clone-row:first').addClass('disabled-row');
                    $(this).children('.clone-row:not(.disabled-row)').each(function(i, e) {

                        $(this).remove();
                    });
                });

                return item;
            },
            add_item_callback: function(item) {

                item.find('.sub-cloneable').each(function() {
                    $(this).cloneable({
                        name_int_ignore: 1,
                        delete_button: '.delete-subitem',
                        add_item_callback: function(subItem) {
                            if (subItem.find('a.help, div.help').length > 0 && jQuery().tipsy) {
                                subItem.find('a.help, div.help').tipsy({gravity: 'w'});
                            }
                        }
                    });
                });
            },
            delete_item_callback: function(item) {

                var fieldId = item.find('.field-id').val();

                if (parseInt(fieldId) > 0) {

                    var toDelete = item.parents('.cloneable').find('.to-delete');
                    toDelete.val(toDelete.val() + fieldId + ',');
                }
            }
        });
    });

    $('.custom-field-selection').find('.sub-cloneable').each(function() {
        $(this).cloneable({
            name_int_ignore: 1,
            delete_button: '.delete-subitem',
            add_item_callback: function(subItem) {
                if (subItem.find('a.help, div.help').length > 0 && jQuery().tipsy) {
                    subItem.find('a.help, div.help').tipsy({gravity: 'w'});
                }
            }
        });
    });

    $(document).on('change', '.custom-field-field-type', function(e) {

        var fieldType = $(this).val();
        var fieldOptions = $(this).parents('div.input').siblings('.field-options');

        if (fieldType == 'select') {

            if (fieldOptions.css('display') != 'block') {

                fieldOptions.slideDown();
            }

        } else {

            if (fieldOptions.css('display') == 'block') {

                fieldOptions.slideUp();
            }
        }
    });

    // trigger the on change command for any current field types to open up options if it's a select
    $(document).find('.custom-field-field-type').trigger('change');


    // trigger the sorting for the custom fields
    $('.sortable').sortable({
        stop: function(event, ui) {
            updateSortOrder();
        }
    });

    $('.sortable').parents('form').on('submit', function() {
        updateSortOrder();
    });
});

/**
 * loop the clone rows and update the sequence input
 */
function updateSortOrder()
{
    $('.sortable').children('div.clone-row').each(function(i, e) {
        $(this).find('.sequence-input').val(i);
   });
}

